From d91d2a8d4a53acd861045b736d270998c3dd9c0f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 23 2021 02:23:49 +0000
Subject: [PATCH 2155/2232] Relax restriction on target types of pointer


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 2c03bdf..c76ef19 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -234,8 +234,9 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
 }
 
 fn check_type_ptr(cx: &mut Check, ty: &Ptr) {
-    if let Type::Ident(_) = ty.inner {
-        return;
+    match ty.inner {
+        Type::Ref(_) | Type::Ptr(_) | Type::Fn(_) | Type::Void(_) => {}
+        _ => return,
     }
 
     cx.error(ty, "unsupported pointer type");

